;;;; "shim" module for compatibility with CHICKEN 5

(module chicken.blob
  (blob->string
   string->blob
   blob?
   blob=?
   blob-size
   make-blob
   blob->f32vector blob->f64vector blob->s32vector blob->u32vector blob->s16vector
   blob->u16vector blob->s8vector blob->u8vector blob->s64vector blob->u64vector
   blob->f32vector/shared blob->f64vector/shared blob->s32vector/shared
   blob->u32vector/shared blob->s16vector/shared blob->u16vector/shared
   blob->s8vector/shared blob->u8vector/shared
   blob->s64vector/shared blob->u64vector/shared
   f32vector->blob f64vector->blob s32vector->blob s32vector->blob u16vector->blob
   s16vector->blob s8vector->blob u8vector->blob s64vector->blob u64vector->blob
   f32vector->blob/shared f64vector->blob/shared s32vector->blob/shared
   s32vector->blob/shared u16vector->blob/shared s16vector->blob/shared
   s8vector->blob/shared u8vector->blob/shared s64vector->blob/shared
   u64vector->blob/shared)

  (import scheme (chicken base)
          (rename (chicken bytevector)
                  (make-bytevector make-blob)
                  (bytevector? blob?)
                  (bytevector-length blob-size)
                  (latin1->string blob->string)
                  (string->latin1 string->blob)
                  (bytevector=? blob=?)))

  (import (rename (chicken number-vector)
                  (bytevector->f32vector blob->f32vector)
                  (bytevector->f64vector blob->f64vector)
                  (bytevector->s16vector blob->s16vector)
                  (bytevector->s32vector blob->s32vector)
                  (bytevector->s64vector blob->s64vector)
                  (bytevector->s8vector blob->s8vector)
                  (bytevector->u16vector blob->u16vector)
                  (bytevector->u32vector blob->u32vector)
                  (bytevector->u64vector blob->u64vector)

                  (f32vector->bytevector f32vector->blob)
                  (f64vector->bytevector f64vector->blob)
                  (s16vector->bytevector s16vector->blob)
                  (s32vector->bytevector s32vector->blob)
                  (s64vector->bytevector s64vector->blob)
                  (s8vector->bytevector s8vector->blob)
                  (u16vector->bytevector u16vector->blob)
                  (u32vector->bytevector u32vector->blob)
                  (u64vector->bytevector u64vector->blob)

                  (bytevector->f32vector/shared blob->f32vector/shared)
                  (bytevector->f64vector/shared blob->f64vector/shared)
                  (bytevector->s16vector/shared blob->s16vector/shared)
                  (bytevector->s32vector/shared blob->s32vector/shared)
                  (bytevector->s64vector/shared blob->s64vector/shared)
                  (bytevector->s8vector/shared blob->s8vector/shared)
                  (bytevector->u16vector/shared blob->u16vector/shared)
                  (bytevector->u32vector/shared blob->u32vector/shared)
                  (bytevector->u64vector/shared blob->u64vector/shared)

                  (f32vector->bytevector/shared f32vector->blob/shared)
                  (f64vector->bytevector/shared f64vector->blob/shared)
                  (s16vector->bytevector/shared s16vector->blob/shared)
                  (s32vector->bytevector/shared s32vector->blob/shared)
                  (s64vector->bytevector/shared s64vector->blob/shared)
                  (s8vector->bytevector/shared s8vector->blob/shared)
                  (u16vector->bytevector/shared u16vector->blob/shared)
                  (u32vector->bytevector/shared u32vector->blob/shared)
                  (u64vector->bytevector/shared u64vector->blob/shared)))

(define (blob->u8vector x)
  (##sys#check-bytevector x 'blob->u8vector)
  (let ((new (##sys#make-bytevector (##sys#size x))))
    (##core#inline "C_copy_block" x new) ) )

(define u8vector->blob blob->u8vector)

(define (blob->u8vector/shared x)
  (##sys#check-bytevector x 'blob->u8vector)
  x)

(define u8vector->blob/shared blob->u8vector/shared)

)
